const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Time_entriesDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const time_entries = await db.time_entries.create(
      {
        id: data.id || undefined,

        date: data.date || null,
        start: data.start || null,
        end: data.end || null,
        break_minutes: data.break_minutes || null,
        job_code: data.job_code || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await time_entries.setTimecard(data.timecard || null, {
      transaction,
    });

    await time_entries.setOrganizations(data.organizations || null, {
      transaction,
    });

    return time_entries;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const time_entriesData = data.map((item, index) => ({
      id: item.id || undefined,

      date: item.date || null,
      start: item.start || null,
      end: item.end || null,
      break_minutes: item.break_minutes || null,
      job_code: item.job_code || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const time_entries = await db.time_entries.bulkCreate(time_entriesData, {
      transaction,
    });

    // For each item created, replace relation files

    return time_entries;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const time_entries = await db.time_entries.findByPk(
      id,
      {},
      { transaction },
    );

    const updatePayload = {};

    if (data.date !== undefined) updatePayload.date = data.date;

    if (data.start !== undefined) updatePayload.start = data.start;

    if (data.end !== undefined) updatePayload.end = data.end;

    if (data.break_minutes !== undefined)
      updatePayload.break_minutes = data.break_minutes;

    if (data.job_code !== undefined) updatePayload.job_code = data.job_code;

    updatePayload.updatedById = currentUser.id;

    await time_entries.update(updatePayload, { transaction });

    if (data.timecard !== undefined) {
      await time_entries.setTimecard(
        data.timecard,

        { transaction },
      );
    }

    if (data.organizations !== undefined) {
      await time_entries.setOrganizations(
        data.organizations,

        { transaction },
      );
    }

    return time_entries;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const time_entries = await db.time_entries.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of time_entries) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of time_entries) {
        await record.destroy({ transaction });
      }
    });

    return time_entries;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const time_entries = await db.time_entries.findByPk(id, options);

    await time_entries.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await time_entries.destroy({
      transaction,
    });

    return time_entries;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const time_entries = await db.time_entries.findOne(
      { where },
      { transaction },
    );

    if (!time_entries) {
      return time_entries;
    }

    const output = time_entries.get({ plain: true });

    output.timecard = await time_entries.getTimecard({
      transaction,
    });

    output.organizations = await time_entries.getOrganizations({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userOrganizations = (user && user.organizations?.id) || null;

    if (userOrganizations) {
      if (options?.currentUser?.organizationsId) {
        where.organizationsId = options.currentUser.organizationsId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.timecards,
        as: 'timecard',

        where: filter.timecard
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.timecard
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  period: {
                    [Op.or]: filter.timecard
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.organizations,
        as: 'organizations',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.job_code) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('time_entries', 'job_code', filter.job_code),
        };
      }

      if (filter.calendarStart && filter.calendarEnd) {
        where = {
          ...where,
          [Op.or]: [
            {
              start: {
                [Op.between]: [filter.calendarStart, filter.calendarEnd],
              },
            },
            {
              end: {
                [Op.between]: [filter.calendarStart, filter.calendarEnd],
              },
            },
          ],
        };
      }

      if (filter.dateRange) {
        const [start, end] = filter.dateRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            date: {
              ...where.date,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            date: {
              ...where.date,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.startRange) {
        const [start, end] = filter.startRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            start: {
              ...where.start,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            start: {
              ...where.start,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.endRange) {
        const [start, end] = filter.endRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            end: {
              ...where.end,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            end: {
              ...where.end,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.break_minutesRange) {
        const [start, end] = filter.break_minutesRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            break_minutes: {
              ...where.break_minutes,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            break_minutes: {
              ...where.break_minutes,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          organizationsId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.organizationsId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.time_entries.findAndCountAll(
        queryOptions,
      );

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('time_entries', 'job_code', query),
        ],
      };
    }

    const records = await db.time_entries.findAll({
      attributes: ['id', 'job_code'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['job_code', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.job_code,
    }));
  }
};
